#include <windows.h>

#include "OgreDrawDevice.h"

/**
 * RXgN^
 */
tTVPOgreDrawDevice::tTVPOgreDrawDevice(OgreInfo *info)
{
	ogreInfo = info;
	_renderWindow = NULL;
	_sceneManager = ogreInfo->root->createSceneManager(ST_GENERIC, "ExampleSMInstance");
}

/**
 * fXgN^
 */
tTVPOgreDrawDevice::~tTVPOgreDrawDevice()
{
	detach();
}

/**
 * EChE̍Đݒ
 * @param hwnd nh
 */
void
tTVPOgreDrawDevice::attach(HWND hwnd)
{
	// TCY
	RECT rect;
	GetClientRect(hwnd, &rect);
	width  = rect.right - rect.left;
	height = rect.bottom - rect.top;

	// nh𕶎
	char hwndName[100];
	snprintf(hwndName, sizeof hwndName, "%d", hwnd);

	// EChE
	windowName = "window";
	windowName += hwndName;
	
	// p[^
	NameValuePairList params;
	params["parentWindowHandle"] = hwndName;
	params["left"] = "0";
	params["top"] = "0";
	
	// EChE
	_renderWindow = ogreInfo->root->createRenderWindow(windowName,
													   width,
													   height,
													   false,
													   &params);

	// XX eXgp
	init();
	
	// ogre 쓮Jn
	ogreInfo->start();
}

/**
 * EChẺ
 */
void
tTVPOgreDrawDevice::detach()
{
	ogreInfo->stop();
	if (_renderWindow) {
		_sceneManager->destroyAllCameras();
		_renderWindow->removeAllViewports();
		_renderWindow->removeAllListeners();
		ogreInfo->root->getRenderSystem()->destroyRenderWindow(windowName);
		_renderWindow = NULL;
	}
}

/***
 * EChE̎w
 * @param wnd EChEnh
 */
void TJS_INTF_METHOD
tTVPOgreDrawDevice::SetTargetWindow(HWND wnd)
{
	detach();
	if (wnd != NULL) {
		attach(wnd);
	}
}

/**
 * rbg}bvRs[Jn
 */
void TJS_INTF_METHOD
tTVPOgreDrawDevice::StartBitmapCompletion(iTVPLayerManager * manager)
{
	// bitmapJn
}

/**
 * rbg}bvRs[
 */
void TJS_INTF_METHOD
tTVPOgreDrawDevice::NotifyBitmapCompleted(iTVPLayerManager * manager,
	tjs_int x, tjs_int y, const void * bits, const BITMAPINFO * bitmapinfo,
	const tTVPRect &cliprect, tTVPLayerType type, tjs_int opacity)
{
	// bits, bitmapinfo ŕ\rbg}bv cliprect ̗̈Ax, y ɕ`悷B
}

/**
 * rbg}bvRs[I
 */
void TJS_INTF_METHOD
tTVPOgreDrawDevice::EndBitmapCompletion(iTVPLayerManager * manager)
{
	// bitmap I
}

//---------------------------------------------------------------------------

/**
 * eXgp
 */
void
tTVPOgreDrawDevice::init()
{
	// J
	Camera *camera = _sceneManager->createCamera("Player");
	camera->setPosition(Vector3(0,0,500));
	camera->lookAt(Vector3(0,0,-300));
	camera->setNearClipDistance(5);

	// r[|[g
	Viewport* vp = _renderWindow->addViewport(camera);
	vp->setBackgroundColour(ColourValue(0,0,0));

	// \[X
	ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
	
	// eXgpɃIuWFNgzuĂ݂
	_sceneManager->setAmbientLight(ColourValue(0.5, 0.5, 0.5));
	Entity *ent = _sceneManager->createEntity("head", "ogrehead.mesh");
	_sceneManager->getRootSceneNode()->createChildSceneNode()->attachObject(ent);
	
	// Green nimbus around Ogre
	ParticleSystem* pSys1 = _sceneManager->createParticleSystem("Nimbus", 
																"Examples/GreenyNimbus");
	_sceneManager->getRootSceneNode()->createChildSceneNode()->attachObject(pSys1);
	
	// Create a rainstorm 
	ParticleSystem* pSys4 = _sceneManager->createParticleSystem("rain", 
																"Examples/Rain");
	SceneNode* rNode = _sceneManager->getRootSceneNode()->createChildSceneNode();
	rNode->translate(0,1000,0);
	rNode->attachObject(pSys4);
	// Fast-forward the rain so it looks more natural
	pSys4->fastForward(5);
	
	// Aureola around Ogre perpendicular to the ground
	ParticleSystem* pSys5 = _sceneManager->createParticleSystem("Aureola", 
																"Examples/Aureola");
	_sceneManager->getRootSceneNode()->createChildSceneNode()->attachObject(pSys5);
	
	// Set nonvisible timeout
	ParticleSystem::setDefaultNonVisibleUpdateTimeout(5);
}
